
data Exists {A : Set}(P : A -> Set) : Set where
  existsI : (x : A) -> P x -> Exists P

infixr 2 /\
infixr 1 \/

data (/\) (A,B : Set) : Set where
  andI : A -> B -> A /\ B

data (\/) (A,B : Set) : Set where
  orI1 : A -> A \/ B
  orI2 : B -> A \/ B

data True : Set where
  tt : True

data False : Set where

absElim (C : Set) : False -> C

andE1 (A,B : Set) : A /\ B -> A
andE1 (andI a _) = a

andE2 (A,B : Set) : A /\ B -> B
andE2 (andI _ b) = b

orE (A,B,C : Set) : A \/ B -> (A -> C) -> (B -> C) -> C
orE (orI1 x) f g = f x
orE (orI2 y) f g = g y

