
-- # import prelude
-- # import eqchain
-- # import typechecker

{--------------------------------------------------------------------------
    The type inference algorithm is sound by construction. Now we prove
    that it's complete.
 --------------------------------------------------------------------------}

inferComplete (n : Nat)(ctx : Ctx n)(t : Typ) :
	      (e : Term ctx t) -> infer ctx (erase e) == correct t e
inferComplete (var i)		      = refl
inferComplete ((@) {_} {_} {s} e1 e2) =
    rewrite inferComplete e1
	    inferComplete e2
	    compareTypeComplete s
    in refl
inferComplete (lam e) = rewrite inferComplete e in refl

