
data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data Vec (A : Set) : Nat -> Set where
  nil	         : Vec A zero
  (::) (n : Nat) : A -> Vec A n -> Vec A (suc n)

data (×) (A,B : Set) : Set where
  pair : A -> B -> A × B

-- zip

zip (A, B : Set)(n : Nat) :
    Vec A n -> Vec B n -> Vec (A × B) n
zip []	      []	= []
zip (x :: xs) (y :: ys) = pair x y :: zip xs ys

