
-- # import Setoid

sig Category : #2 where
  Obj		      : Type
  Arr		      : Obj -> Obj -> Setoid
  id   (a:Obj)	      : El (Arr a a)
  comp (a,b,c:Obj)    : El (Arr b c) -> El (Arr a b) -> El (Arr a c)

  leftId  (a,b:Obj)   : (f : El (Arr a b)) -> Prf (comp a b b (id b) f == f)
  rightId (a,b:Obj)   : (f : El (Arr a b)) -> Prf (comp a a b f (id a) == f)
  assoc (a,b,c,d:Obj) :
      (f : El (Arr c d)) -> (g : El (Arr b c)) -> (h : El (Arr a b)) ->
      Prf (f ∘ (g ∘ h) == (f ∘ g) ∘ h)
    where
      infixl 12 ∘
      (∘) (a,b,c:Obj) : El (Arr b c) -> El (Arr a b) -> El (Arr a c)
      f ∘ g = comp _ _ _ f g

(-->) (C:Category) : C.Obj -> C.Obj -> Set
(-->) {C} A B = El (C.Arr A B)

id (C:Category)(a:C.Obj) : a --> a
id {C} = C.id

(∘) (C:Category)(a,b,c:C.Obj) : (b --> c) -> (a --> b) -> (a --> c)
(∘) {C} f g = C.comp f g

