
module TypeChecker.Uncurry where

import Syntax.Internal

import TypeChecker.UnfoldConstants

curryPi :: Int -> Value -> Value
curryPi n v = VPi v (mkCl "_" v w)
    where
	(v, w) = curry' n v

	curry' 1 v = (w, f)
	    where VPi w (Cl x _ u) t = unfoldConstants v
curryPi 1 v = case unfoldConstants v of
		VPi _ _ _   -> v	-- make sure we apply it correctly
curryPi n v = VSigma "_" w "_" (clMap (\v' -> curryPi (n - 1)) t
    where
	VPi w f t = unfoldConstants v

-- uncurryPi :: Int -> Value -> Value
-- uncurryPi

