{-
    The FOL-plugin isn't completely safe. The following example shows how
    to prove a == b for any a and b.
-}

-- # import Property

Unit : Set
one : Unit

allEq : (x, y : Unit) -> x == y
oneEq : (x : Unit) -> x == one

A : Set
a : A
b : A

-- This works since gandalf uses resolution to prove equalities.
bad : a == b
bad = fol-plugin(allEq)

-- This works since gandalf does paramodulation to/from variables.
notsobad : a == b
notsobad = fol-plugin(oneEq)

